<template>
	<ContentWrap>
		<!-- 搜索工作栏 -->
		<el-form
			class="-mb-15px"
			:model="queryParams"
			ref="queryFormRef"
			:inline="true"
			label-width="68px"
		>
			<el-form-item label="月嫂姓名" prop="yuesaoId">
				<el-input
					v-model="queryParams.name"
					placeholder="请输入月嫂姓名"
					clearable
					@keyup.enter="handleQuery"
					class="!w-240px"
				/>
			</el-form-item>
			<!--      <el-form-item label="月嫂头像地址" prop="avatar">-->
			<!--        <el-input-->
			<!--          v-model="queryParams.avatar"-->
			<!--          placeholder="请输入月嫂头像地址"-->
			<!--          clearable-->
			<!--          @keyup.enter="handleQuery"-->
			<!--          class="!w-240px"-->
			<!--        />-->
			<!--      </el-form-item>-->
			<!--      <el-form-item label="微信号" prop="wechat">-->
			<!--        <el-input-->
			<!--          v-model="queryParams.wechat"-->
			<!--          placeholder="请输入微信号"-->
			<!--          clearable-->
			<!--          @keyup.enter="handleQuery"-->
			<!--          class="!w-240px"-->
			<!--        />-->
			<!--      </el-form-item>-->
			<!--      <el-form-item label="手机号" prop="mobile">-->
			<!--        <el-input-->
			<!--          v-model="queryParams.mobile"-->
			<!--          placeholder="请输入手机号"-->
			<!--          clearable-->
			<!--          @keyup.enter="handleQuery"-->
			<!--          class="!w-240px"-->
			<!--        />-->
			<!--      </el-form-item>-->
			<!--      <el-form-item label="学历" prop="schoolDegree">-->
			<!--        <el-input-->
			<!--          v-model="queryParams.schoolDegree"-->
			<!--          placeholder="请输入学历"-->
			<!--          clearable-->
			<!--          @keyup.enter="handleQuery"-->
			<!--          class="!w-240px"-->
			<!--        />-->
			<!--      </el-form-item>-->
			<!--      <el-form-item label="工作历史" prop="workHistory">-->
			<!--        <el-input-->
			<!--          v-model="queryParams.workHistory"-->
			<!--          placeholder="请输入工作历史"-->
			<!--          clearable-->
			<!--          @keyup.enter="handleQuery"-->
			<!--          class="!w-240px"-->
			<!--        />-->
			<!--      </el-form-item>-->
			<!--      <el-form-item label="工作技能" prop="workSkill">-->
			<!--        <el-input-->
			<!--          v-model="queryParams.workSkill"-->
			<!--          placeholder="请输入工作技能"-->
			<!--          clearable-->
			<!--          @keyup.enter="handleQuery"-->
			<!--          class="!w-240px"-->
			<!--        />-->
			<!--      </el-form-item>-->
			<!--      <el-form-item label="期望薪资" prop="expectedSalary">-->
			<!--        <el-input-->
			<!--          v-model="queryParams.expectedSalary"-->
			<!--          placeholder="请输入期望薪资"-->
			<!--          clearable-->
			<!--          @keyup.enter="handleQuery"-->
			<!--          class="!w-240px"-->
			<!--        />-->
			<!--      </el-form-item>-->
			<!--      <el-form-item label="年龄" prop="age">-->
			<!--        <el-input-->
			<!--          v-model="queryParams.age"-->
			<!--          placeholder="请输入年龄"-->
			<!--          clearable-->
			<!--          @keyup.enter="handleQuery"-->
			<!--          class="!w-240px"-->
			<!--        />-->
			<!--      </el-form-item>-->
			<!--      <el-form-item label="籍贯" prop="origin">-->
			<!--        <el-input-->
			<!--          v-model="queryParams.origin"-->
			<!--          placeholder="请输入籍贯"-->
			<!--          clearable-->
			<!--          @keyup.enter="handleQuery"-->
			<!--          class="!w-240px"-->
			<!--        />-->
			<!--      </el-form-item>-->
			<!--      <el-form-item label="子女数" prop="hasChildren">-->
			<!--        <el-input-->
			<!--          v-model="queryParams.hasChildren"-->
			<!--          placeholder="请输入子女数"-->
			<!--          clearable-->
			<!--          @keyup.enter="handleQuery"-->
			<!--          class="!w-240px"-->
			<!--        />-->
			<!--      </el-form-item>-->
			<!--      <el-form-item label="从业时长年" prop="workYear">-->
			<!--        <el-input-->
			<!--          v-model="queryParams.workYear"-->
			<!--          placeholder="请输入从业时长年"-->
			<!--          clearable-->
			<!--          @keyup.enter="handleQuery"-->
			<!--          class="!w-240px"-->
			<!--        />-->
			<!--      </el-form-item>-->
			<!--      <el-form-item label="民族" prop="nation">-->
			<!--        <el-input-->
			<!--          v-model="queryParams.nation"-->
			<!--          placeholder="请输入民族"-->
			<!--          clearable-->
			<!--          @keyup.enter="handleQuery"-->
			<!--          class="!w-240px"-->
			<!--        />-->
			<!--      </el-form-item>-->
			<!--      <el-form-item label="自我介绍" prop="selfIntro">-->
			<!--        <el-input-->
			<!--          v-model="queryParams.selfIntro"-->
			<!--          placeholder="请输入自我介绍"-->
			<!--          clearable-->
			<!--          @keyup.enter="handleQuery"-->
			<!--          class="!w-240px"-->
			<!--        />-->
			<!--      </el-form-item>-->
			<!--      <el-form-item label="个人标签" prop="selfRemarks">-->
			<!--        <el-input-->
			<!--          v-model="queryParams.selfRemarks"-->
			<!--          placeholder="请输入个人标签"-->
			<!--          clearable-->
			<!--          @keyup.enter="handleQuery"-->
			<!--          class="!w-240px"-->
			<!--        />-->
			<!--      </el-form-item>-->
			<!--      <el-form-item label="是否有保险 1=是 0=否" prop="isBaoxian">-->
			<!--        <el-input-->
			<!--          v-model="queryParams.isBaoxian"-->
			<!--          placeholder="请输入是否有保险 1=是 0=否"-->
			<!--          clearable-->
			<!--          @keyup.enter="handleQuery"-->
			<!--          class="!w-240px"-->
			<!--        />-->
			<!--      </el-form-item>-->
			<!--      <el-form-item label="是否体检 1=是 0=否" prop="isTijian">-->
			<!--        <el-input-->
			<!--          v-model="queryParams.isTijian"-->
			<!--          placeholder="请输入是否体检 1=是 0=否"-->
			<!--          clearable-->
			<!--          @keyup.enter="handleQuery"-->
			<!--          class="!w-240px"-->
			<!--        />-->
			<!--      </el-form-item>-->
			<!--      <el-form-item label="保险证明路径" prop="baoxianUrl">-->
			<!--        <el-input-->
			<!--          v-model="queryParams.baoxianUrl"-->
			<!--          placeholder="请输入保险证明路径"-->
			<!--          clearable-->
			<!--          @keyup.enter="handleQuery"-->
			<!--          class="!w-240px"-->
			<!--        />-->
			<!--      </el-form-item>-->
			<!--      <el-form-item label="保险更新时间" prop="baoxianTime">-->
			<!--        <el-date-picker-->
			<!--          v-model="queryParams.baoxianTime"-->
			<!--          value-format="YYYY-MM-DD HH:mm:ss"-->
			<!--          type="daterange"-->
			<!--          start-placeholder="开始日期"-->
			<!--          end-placeholder="结束日期"-->
			<!--          :default-time="[new Date('1 00:00:00'), new Date('1 23:59:59')]"-->
			<!--          class="!w-240px"-->
			<!--        />-->
			<!--      </el-form-item>-->
			<!--      <el-form-item label="体检证明路径" prop="tijianUrl">-->
			<!--        <el-input-->
			<!--          v-model="queryParams.tijianUrl"-->
			<!--          placeholder="请输入体检证明路径"-->
			<!--          clearable-->
			<!--          @keyup.enter="handleQuery"-->
			<!--          class="!w-240px"-->
			<!--        />-->
			<!--      </el-form-item>-->
			<!--      <el-form-item label="体检更新时间" prop="tijianTime">-->
			<!--        <el-date-picker-->
			<!--          v-model="queryParams.tijianTime"-->
			<!--          value-format="YYYY-MM-DD HH:mm:ss"-->
			<!--          type="daterange"-->
			<!--          start-placeholder="开始日期"-->
			<!--          end-placeholder="结束日期"-->
			<!--          :default-time="[new Date('1 00:00:00'), new Date('1 23:59:59')]"-->
			<!--          class="!w-240px"-->
			<!--        />-->
			<!--      </el-form-item>-->
			<!--      <el-form-item label="身份证号" prop="identityNumber">-->
			<!--        <el-input-->
			<!--          v-model="queryParams.identityNumber"-->
			<!--          placeholder="请输入身份证号"-->
			<!--          clearable-->
			<!--          @keyup.enter="handleQuery"-->
			<!--          class="!w-240px"-->
			<!--        />-->
			<!--      </el-form-item>-->
			<!--      <el-form-item label="是否背调" prop="isBeidiao">-->
			<!--        <el-input-->
			<!--          v-model="queryParams.isBeidiao"-->
			<!--          placeholder="请输入是否背调"-->
			<!--          clearable-->
			<!--          @keyup.enter="handleQuery"-->
			<!--          class="!w-240px"-->
			<!--        />-->
			<!--      </el-form-item>-->
			<!--      <el-form-item label="背调时间" prop="beidiaoTime">-->
			<!--        <el-date-picker-->
			<!--          v-model="queryParams.beidiaoTime"-->
			<!--          value-format="YYYY-MM-DD HH:mm:ss"-->
			<!--          type="daterange"-->
			<!--          start-placeholder="开始日期"-->
			<!--          end-placeholder="结束日期"-->
			<!--          :default-time="[new Date('1 00:00:00'), new Date('1 23:59:59')]"-->
			<!--          class="!w-240px"-->
			<!--        />-->
			<!--      </el-form-item>-->
			<!--      <el-form-item label="创建时间" prop="createTime">-->
			<!--        <el-date-picker-->
			<!--          v-model="queryParams.createTime"-->
			<!--          value-format="YYYY-MM-DD HH:mm:ss"-->
			<!--          type="daterange"-->
			<!--          start-placeholder="开始日期"-->
			<!--          end-placeholder="结束日期"-->
			<!--          :default-time="[new Date('1 00:00:00'), new Date('1 23:59:59')]"-->
			<!--          class="!w-240px"-->
			<!--        />-->
			<!--      </el-form-item>-->
			<el-form-item>
				<el-button @click="handleQuery">
					<Icon icon="ep:search" class="mr-5px"/>
					搜索
				</el-button>
				<el-button @click="resetQuery">
					<Icon icon="ep:refresh" class="mr-5px"/>
					重置
				</el-button>
				<el-button
					type="primary"
					plain
					@click="openForm('create')"
					v-hasPermi="['yuesao:resume:create']"
				>
					<Icon icon="ep:plus" class="mr-5px"/>
					新增
				</el-button>
				<el-button
					type="success"
					plain
					@click="handleExport"
					:loading="exportLoading"
					v-hasPermi="['yuesao:resume:export']"
				>
					<Icon icon="ep:download" class="mr-5px"/>
					导出
				</el-button>
			</el-form-item>
		</el-form>
	</ContentWrap>

	<!-- 列表 -->
	<ContentWrap>
		<el-table v-loading="loading" :data="list" :stripe="true" :show-overflow-tooltip="false">
			<el-table-column label="ID" align="center" prop="id" fixed="left"/>
			<el-table-column label="月嫂姓名" align="center" prop="name" fixed="left"/>
			<el-table-column label="月嫂头像" align="center" prop="avatar" fixed="left" min-width="100px">
				<template #default="{row}">
					<viewer :images="[row.avatar]">
						<img v-if="row.avatar" :src="row.avatar" style="width: 60px; height: 60px; object-fit: cover;"/>
						<img v-else src="http://43.138.81.125:8009/i/user/default-avatar.png"
						     style="width: 60px; height: 60px; object-fit: cover;"/>
					</viewer>
				</template>
			</el-table-column>
			<el-table-column label="手机号" align="center" prop="mobile"/>
			<el-table-column label="学历" align="center" prop="schoolDegreeValue"/>
			<el-table-column label="期望薪资" align="center" prop="expectedSalary"/>
			<el-table-column label="年龄" align="center" prop="age"/>
			<el-table-column label="籍贯" align="center" prop="origin"/>
			<el-table-column label="子女数" align="center" prop="hasChildren"/>
			<el-table-column label="从业时长年" align="center" prop="workYear"/>
			<el-table-column label="民族" align="center" prop="nation"/>
			<el-table-column label="自我介绍" align="center" prop="selfIntro"/>
			<el-table-column label="个人标签" width="300" align="center" prop="selfRemarksArray">
				<template #default="{row}">
					<el-tag v-for="(tag, i) in row.selfRemarksArray" :key="i" style="margin-right: 5px">{{ tag }}</el-tag>
				</template>
			</el-table-column>

			<el-table-column label="操作" align="center" fixed="right" min-width="180px">
				<template #default="{ row }">
					<el-button
						link
						type="primary"
						@click="openCompare(row)"
					>
						对比差异
					</el-button>
					<el-button
						link
						type="primary"
						@click="auditPass(row)"
					>
						通过
					</el-button>
					<el-button
						link
						type="primary"
						@click="auditReject(row)"
					>
						拒绝
					</el-button>
				</template>
			</el-table-column>
		</el-table>
		<!-- 分页 -->
		<Pagination
			:total="total"
			v-model:page="queryParams.pageNo"
			v-model:limit="queryParams.pageSize"
			@pagination="getList"
		/>
	</ContentWrap>

	<!-- 表单弹窗：添加/修改 -->
	<ResumeForm ref="formRef" @success="getList"/>
	<Dialog v-model="compareVisible" title="对比差异" width="80%">
		<div class="compare-wrap">
			<ResumeDetail class="resume-item" :info="oldResume" :diffKeys="diffKeys"></ResumeDetail>
			<ResumeDetail class="resume-item" :info="newResume" :diffKeys="diffKeys"></ResumeDetail>
		</div>

		<template #footer>
			<el-button @click="compareVisible = false">关闭</el-button>
		</template>
	</Dialog>
</template>

<script setup lang="ts">
import {dateFormatter} from '@/utils/formatTime'
import download from '@/utils/download'
import * as ResumeApi from '@/api/yuesao/resume'
import ResumeForm from './ResumeForm.vue'
import ResumeDetail from './ResumeDetail.vue'
import {getDifferentKeys} from "@/utils/common";


defineOptions({name: 'Resume'})

const message = useMessage() // 消息弹窗
const {t} = useI18n() // 国际化

const loading = ref(true) // 列表的加载中
const total = ref(0) // 列表的总页数
const list = ref([]) // 列表的数据
const queryParams = reactive({
	pageNo: 1,
	pageSize: 10,
	name: '',
	// id: null,
	// avatar: null,
	// wechat: null,
	// mobile: null,
	// schoolDegree: null,
	// workHistory: null,
	// workSkill: null,
	// expectedSalary: null,
	// age: null,
	// origin: null,
	// hasChildren: null,
	// workYear: null,
	// nation: null,
	// selfIntro: null,
	// selfRemarks: null,
	// isBaoxian: null,
	// isTijian: null,
	// baoxianUrl: null,
	// baoxianTime: [],
	// tijianUrl: null,
	// tijianTime: [],
	// identityNumber: null,
	// isBeidiao: null,
	// beidiaoTime: [],
	// createTime: []
})
const queryFormRef = ref() // 搜索的表单
const exportLoading = ref(false) // 导出的加载中

/** 查询列表 */
const getList = async () => {
	loading.value = true
	try {
		const data = await ResumeApi.getCheckResumePage(queryParams)
		list.value = data.list
		total.value = data.total
	} finally {
		loading.value = false
	}
}

/** 搜索按钮操作 */
const handleQuery = () => {
	queryParams.pageNo = 1
	getList()
}

/** 重置按钮操作 */
const resetQuery = () => {
	queryFormRef.value.resetFields()
	handleQuery()
}

/** 添加/修改操作 */
const formRef = ref()
const openForm = (type: string, id?: number) => {
	formRef.value.open(type, id)
}

/** 删除按钮操作 */
const handleDelete = async (id: number) => {
	try {
		// 删除的二次确认
		await message.delConfirm()
		// 发起删除
		await ResumeApi.deleteResume(id)
		message.success(t('common.delSuccess'))
		// 刷新列表
		await getList()
	} catch {
	}
}

/** 导出按钮操作 */
const handleExport = async () => {
	try {
		// 导出的二次确认
		await message.exportConfirm()
		// 发起导出
		exportLoading.value = true
		const data = await ResumeApi.exportResume(queryParams)
		download.excel(data, '月嫂简历.xls')
	} catch {
	} finally {
		exportLoading.value = false
	}
}


const auditPass = async (row) => {
	try {
		await ResumeApi.audit({yuesaoId: row.id, checkResult: true,})
		message.alert('审核完成')
		await getList()
	} catch {

	}
}

const auditReject = async (row) => {
	const data = await message.prompt('请输入审核不通过的原因', '')
	try {
		await ResumeApi.audit({yuesaoId: row.id, checkResult: false, comment: data.value})
		message.alert('审核完成')
		await getList()
	} catch {

	}
}

const compareVisible = ref(false)
const oldResume = ref()
const newResume = ref()
const diffKeys = ref<string[]>([])
const openCompare = async (row) => {
	compareVisible.value = true
	try {
		const data = await ResumeApi.compare({yuesaoId: row.id})
		oldResume.value = data.oldResume
		newResume.value = data.newResume
		diffKeys.value = getDifferentKeys(oldResume.value, newResume.value)

	} catch {
		//
	}
}

/** 初始化 **/
onMounted(() => {
	getList()
})
</script>

<style scoped lang="less">
.compare-wrap {
	display: flex;

	.resume-detail {
		flex: 1;
	}
}
</style>
